From 3d86b68b89438b1230c4b531aabb44221ccc6726 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jan 21 2016 16:00:40 +0000
Subject: [PATCH 250/254] A first test for the test suite.


---

diff --git a/.gitignore b/.gitignore
index 0e32795..80d44bf 100644
--- a/.gitignore
+++ b/.gitignore
@@ -4,3 +4,4 @@ fedmsg.d/fas_credentials.py
 node*
 build/
 scratch/
+hubs/tests/vcr-request-data
diff --git a/hubs/tests/test_widgets/__init__.py b/hubs/tests/test_widgets/__init__.py
new file mode 100644
index 0000000..dcf90f9
--- /dev/null
+++ b/hubs/tests/test_widgets/__init__.py
@@ -0,0 +1,55 @@
+from os.path import dirname
+import unittest
+
+import vcr
+
+import hubs.models
+
+cassette_dir = dirname(dirname(__file__)) + '/vcr-request-data/'
+
+
+class WidgetTest(unittest.TestCase):
+    def setUp(self):
+        filename = cassette_dir + self.id()
+        self.vcr = vcr.use_cassette(filename, record_mode='new_episodes')
+        self.vcr.__enter__()
+
+        import hubs.app
+        hubs.app.fedmsg_config = {
+            'hubs.sqlalchemy.uri': 'sqlite://',  # in memory
+        }
+        hubs.app.session = hubs.models.init(
+            hubs.app.fedmsg_config['hubs.sqlalchemy.uri'],
+            create=True,
+        )
+        self.app = hubs.app.app.test_client()
+        self.app.testing = True
+        self.session = hubs.app.session
+        self.populate()
+
+    def tearDown(self):
+        self.vcr.__exit__()
+        self.session.remove()
+
+
+    def populate(self):
+        for user in ['devyani7', 'dhrish', 'shalini', 'ralph', 'decause']:
+            openid = '%s.id.fedoraproject.org' % user
+            fullname = user.title()
+            hubs.models.User.get_or_create(
+                hubs.app.session, openid=openid, fullname=fullname)
+
+        for team in ['i18n', 'infra']:
+            hub = hubs.models.Hub(name=team, summary="the %s team" % team)
+            hubs.app.session.add(hub)
+
+
+    # TODO - test that it is in the registry
+    # TODO - test that it has all the things it needs
+
+    def widget_instance(self, hubname, plugin):
+        hub = hubs.models.Hub.by_name(self.session, hubname)
+        for widget in hub.widgets:
+            if widget.plugin == plugin:
+                return widget
+        raise KeyError("No such widget found for %s/%s" % (hubname, plugin))
diff --git a/hubs/tests/test_widgets/test_badges.py b/hubs/tests/test_widgets/test_badges.py
new file mode 100644
index 0000000..9005b2f
--- /dev/null
+++ b/hubs/tests/test_widgets/test_badges.py
@@ -0,0 +1,15 @@
+import json
+
+import hubs.tests.test_widgets
+
+
+class TestBadges(hubs.tests.test_widgets.WidgetTest):
+    plugin = 'badges'  # The name in hubs.widgets.registry
+
+    def test_data_simple(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        response = self.app.get('/ralph/%i/json/' % widget.idx)
+        assert response.status_code == 200, response.status_code
+        data = json.loads(response.data)
+        self.assertEquals(data['plugin'], 'badges')
+        assert 'assertions' in data['data'], data['data'].keys()
diff --git a/setup.cfg b/setup.cfg
new file mode 100644
index 0000000..963de6b
--- /dev/null
+++ b/setup.cfg
@@ -0,0 +1,4 @@
+[nosetests]
+verbosity=2
+nocapture=1
+with-yanc=1
